'' Another Armour Ranger Adventure!
''
'' by ssjx (October 2021) [http://ssjx.co.uk]
'' ==============================================================
''
''
randomize 

#include "bmp.bi"
#include "header.bi"
#include "fmod.bi"

common shared sample() As Integer

declare sub infobar(txt as string)

declare sub set_message(txt as string)
declare sub display_message()

'' 
declare sub anim_intro2()
declare sub anim_crash()

declare sub fastcls()

'' In this file...
declare sub create_solid_map()

dim shared sprite(20) as any ptr
dim shared shot_spr(4) as any ptr
dim shared enemy_spr(7) as any ptr

dim shared portal_spr(3) as any ptr
dim shared portal_frame as integer

dim shared explo_sprite as any ptr
dim shared tele_sprite as any ptr
dim shared snow_sprite as any ptr

dim shared player_spr(20) as any ptr
dim shared as integer alt=0,fc=0,force_ext,mission

''
'' Use world to define the area type (1=space,2=forest,3=rock,4=ice,5=lake,6=desert)
''

type myworld
	'' 0=blank,1=space,2=forest,3=rock,4=ice
	dim world(16) as integer=>{_
	1,0,0,0,_
	0,0,3,6,_
	0,4,2,5,_
	0,0,0,0_
	}
	
	dim as integer wx=-1	
	dim as integer wy=-1 	
	dim as integer location=-1

	declare sub show()
	declare sub reset()
	declare sub set(as integer, as integer)
	declare sub move(as integer, as integer)
end type

sub myworld.reset()

	#if CHEAT=1
		set(2,2)
	#else
		set(0,0)
	#endif

end sub

sub myworld.show()

	dim as integer ps

	color rgb(0,0,0)
	for j as integer=0 to 3
		for i as integer=0 to 3
			ps=(j*4)+i
			draw string (20+(i*20)+1,20+(j*20)+1),str(world(ps))
			if (i=wx) and (j=wy) then draw string (20+(i*20)+1,20+(j*20)+1),"_"
		next
	next
	
	draw string (20,20+(5*20)),"Location: "+str(location)
	
	color rgb(255,255,0)
	for j as integer=0 to 3
		for i as integer=0 to 3
			ps=(j*4)+i
			draw string (20+(i*20),20+(j*20)),str(world(ps))
			if (i=wx) and (j=wy) then draw string (20+(i*20),20+(j*20)),"_"
		next
	next
	
	draw string (20+1,20+(5*20)+1),"Location: "+str(location)
	
end sub

sub myworld.move(xd as integer,yd as integer)
	''
	if (wx+xd)>=0 then wx+=xd
	if (wy+yd)>=0 then wy+=yd
	
	set(wx,wy)
	
	'dim as integer ps=(wy*4)+wx
	'location=world(ps)-1
end sub

sub myworld.set(x as integer,y as integer)
'	if (x>=0) and (y>=0) then 
		wx=x
		wy=y
		dim as integer ps=(wy*4)+wx
		
		location=world(ps)-1
'	end if
end sub

dim shared as myworld world

''
''
''

type mapsquare
	sprite as ubyte
	visible as ubyte
end type

dim shared basemap(32*32) as ubyte

dim shared station(32,32) as mapsquare	'' 
dim shared forest(32,32) as mapsquare	'' 
dim shared mountain(32,32) as mapsquare	'' 
dim shared ice(32,32) as mapsquare		'' 
dim shared lake(32,32) as mapsquare		'' 
dim shared desert(32,32) as mapsquare	'' 

''
dim shared map(32,32) as ubyte		'' Current
dim shared visible(32,32) as ubyte	'' 
dim shared solid(32,32) as ubyte	''

dim shared as xy mymap
dim shared as integer movedir=0,cog

dim shared mapwidth as integer
dim shared mapheight as integer

dim shared as integer esc=0
dim shared as integer spacedown=0

dim shared as boolean one_down=0
dim shared as boolean two_down=0
dim shared as boolean three_down=0

type myplayer
	a as integer
	x as integer
	ox as integer
	y as integer
	oy as integer
	xdir as integer
	ydir as integer
	f as integer	'' frame
	firedelay as integer
	visible as integer
	health as integer
	''
	has_armour as boolean
	spr_offset as integer
	''
	has_rockets as boolean
	has_keycard as boolean
	has_freeze as boolean	''
	has_heat as boolean		'' 
	has_omni as boolean		''
	
	has_teleport as boolean		'' 
	
	rockets as integer
	freeze as integer	'' 
	heat as integer		'' 
	omni as integer		'' 
	
	diamond as integer		''
	
	''
	hostages_rescued as boolean
	hostages as integer
	sat as integer
	
	spawn as integer	'' Delay
	stun as integer		'' Delay
	''	
	declare sub reset()
	declare function contains(as integer,as integer) as integer
end type

sub myplayer.reset()
	x=6
	y=6
	ox=0
	oy=0
	xdir=0
	ydir=1		'' Facing downward
	f=4			'' Sprite
	health=5
	diamond=0
	spr_offset=0	'' Normal player
	
	rockets=0
	freeze=0	'' 
	heat=0		'' 
	omni=0	
	
	has_rockets=false
	has_keycard=false
	has_freeze=false
	has_heat=false
	has_teleport=false
	has_armour=false
	has_omni=false
	
	' Cheat!
	if CHEAT=1 then
		health=10
		rockets=5
		has_keycard=true
		has_freeze=true
		has_heat=true
		has_rockets=true
		has_armour=true	
		spr_offset=10	'' Armoured player
	end if
	
	hostages_rescued=false
	hostages=0
	sat=0
	
	spawn=0	'' Used by enemy
	stun=0	'' Used by enemy
end sub

function myplayer.contains(sx as integer,sy as integer) as integer
	dim as integer ax=(x*32)+ox
	dim as integer ay=(y*32)+oy
	
	if sx>ax and sx<(ax+32) then
		if sy>ay and sy<(ay+32) then
			return 1
		end if
	end if
	
	return 0
end function

dim shared as myplayer player
dim shared as myplayer ghost(10)

''
''
''
dim shared as xy snow(80)

sub snow_set()	
	for i as integer=0 to ubound(snow)
		with snow(i)
			.x=int(rnd*(1024))
			.y=int(rnd*(1024))
		end with
	next i
end sub

sub snow_update()
	for i as integer=0 to ubound(snow)
		with snow(i)
			.x+=1
			if .x>=(1024) then .x=0
			
			.y+=1
			if .y>=(1024) then .y=0
		end with
	next i
end sub

sub snow_draw()
	dim as integer mx=(mymap.x*32)-mymap.ox
	dim as integer my=(mymap.y*32)-mymap.oy

	for i as integer=0 to ubound(snow)
		with snow(i)
			put (.x-mx,.y-my),snow_sprite,trans
		end with
	next i
end sub

''
'' Teleport
''

dim shared as xy tele(3)

sub tele_add(ax as integer,ay as integer)	
	for i as integer=0 to ubound(tele)
		with tele(i)
			if .a=0 then
				.a=1
				.x=ax
				.y=ay
				.dist=0
				exit for
			end if
		end with
	next i
end sub

'' Up
sub tele_draw()
	dim as integer mx=(mymap.x*32)-mymap.ox
	dim as integer my=(mymap.y*32)-mymap.oy
	
	for i as integer=0 to ubound(tele)
		with tele(i)
			if .a=1 then
				put (.x-mx,.y-my-.dist),tele_sprite,trans
				
				.dist+=4
				if .dist>480 then .a=0
			end if
		end with
	next
end sub

''
''
''
dim shared as xy explo(20)

sub explo_add(ax as integer,ay as integer)	
	for i as integer=0 to ubound(explo)
		with explo(i)
			if .a=0 then
				.a=1
				.x=ax
				.y=ay
				.dist=0
				exit for
			end if
		end with
	next i
end sub


sub explo_draw()
	dim as integer mx=(mymap.x*32)-mymap.ox
	dim as integer my=(mymap.y*32)-mymap.oy
	
	for i as integer=0 to ubound(explo)
		with explo(i)
			if .a=1 then
				put (.x-mx+.dist,.y-my),explo_sprite,trans
				put (.x-mx,.y-my+.dist),explo_sprite,trans
				put (.x-mx-.dist,.y-my),explo_sprite,trans
				put (.x-mx,.y-my-.dist),explo_sprite,trans
				
				.dist+=2
				if .dist>32 then .a=0
			end if
		end with
	next
end sub

sub explo_reset()
	for i as integer=0 to ubound(explo)
		explo(i).a=0
	next i
end sub

''
'' Enemy shots (basic)
''

dim shared as xy enemy_shot(20)

sub enemy_shot_add(ax as integer,ay as integer,xd as integer,yd as integer,typ as integer)
	dim as integer mx=(mymap.x*32)-mymap.ox
	dim as integer my=(mymap.y*32)-mymap.oy
	
	for i as integer=0 to ubound(enemy_shot)
		with enemy_shot(i)
			if .a=0 then
				.a=typ	'' 1=normal, 2=rocket
				.x=(ax+12)+mx
				.y=(ay+12)+my
				.xdir=xd*4
				.ydir=yd*4
				.ox=0
				.oy=0
				.dist=0
				exit for
			end if
		end with
	next i
end sub

sub enemy_shot_update()
	for i as integer=0 to ubound(enemy_shot)
		with enemy_shot(i)
			if .a>0 then
				.x+=.xdir
				.y+=.ydir
				.dist+=1
				if .dist>192 then .a=0
			end if
			
			if .a>0 then
				'' Hit solid?
				for j as integer=0 to mapheight-1
					for i as integer=0 to mapwidth-1				
						
						'' So enemies can shoot across water/holes...
						dim as boolean skip=false
						if world.location=2 and map(i,j)=4 then skip=true	'' Lava
						if world.location=3 and map(i,j)=4 then skip=true	'' Ice Holes
						if world.location=4 and map(i,j)=4 then skip=true	'' Lake Water
						
						if solid(i,j)>0 and skip=false then
							dim as integer tx=i*32
							dim as integer ty=j*32
							''
							if (.x>tx) and (.x<tx+32) then
								if (.y>ty) and (.y<ty+32) then
									explo_add(.x,.y)
									.a=0
								end if
							end if
							
						end if
						''
					next i
				next j	
			end if
			
			if .a>0 then
				dim as integer mx=(mymap.x*32)-mymap.ox
				dim as integer my=(mymap.y*32)-mymap.oy

				'' Hit Player?
				if player.contains(.x-mx,.y-my)=1 then
					explo_add(mx+(player.x*32)+player.ox+8,my+(player.y*32)+player.oy+8)
					player.health-=1
					.a=0
					FSOUND_PlaySound(FSOUND_FREE, sample(1))
				end if
			
			end if
			
		end with
	next i
	
end sub

sub enemy_shot_draw()
	dim as integer mx=(mymap.x*32)-mymap.ox
	dim as integer my=(mymap.y*32)-mymap.oy
	
	for i as integer=0 to ubound(enemy_shot)
		with enemy_shot(i)
			if .a=1 then put (.x-mx,.y-my),shot_spr(0),trans
		end with
	next i
end sub


sub enemy_shot_reset()
	for i as integer=0 to ubound(enemy_shot)
		enemy_shot(i).a=0
	next i
end sub

''
'' Player shots
''

dim shared as xy shot(20)

sub shot_add(ax as integer,ay as integer,xd as integer,yd as integer,typ as integer)
	dim as integer mx=(mymap.x*32)-mymap.ox
	dim as integer my=(mymap.y*32)-mymap.oy
	
	for i as integer=0 to ubound(shot)
		with shot(i)
			if .a=0 then
				.a=typ	'' 1=normal, 2=rocket
				.x=(ax+12)+mx
				.y=(ay+12)+my
				.xdir=xd*4
				.ydir=yd*4
				.ox=0
				.oy=0
				.dist=0
				
				FSOUND_PlaySound(FSOUND_FREE, sample(0))
				
				exit for
			end if
		end with
	next i
end sub

sub shot_update()
	
	for i as integer=0 to ubound(shot)
		with shot(i)
			if .a>0 then
				.x+=.xdir
				.y+=.ydir
				.dist+=1
				if .dist>192 then .a=0
			end if
			
			if .a>0 then
				'' Hit solid?
				for j as integer=0 to mapheight-1
					for i as integer=0 to mapwidth-1				
						
						'' So we can shoot across water/holes...
						dim as boolean skip=false
						if world.location=2 and map(i,j)=4 and .a<>4 and .a<>9 then skip=true	'' Lava
						if world.location=3 and map(i,j)=4 then skip=true	'' Ice Holes
						if world.location=4 and map(i,j)=4 and .a<>4 and .a<>9 then skip=true	'' Lake Water
						
						
						if solid(i,j)>0 and skip=false then
							dim as integer tx=i*32
							dim as integer ty=j*32
							''
						
								if (.x>tx) and (.x<tx+32) then
									if (.y>ty) and (.y<ty+32) then
										
										explo_add(.x,.y)
										
										'FSOUND_PlaySound(FSOUND_FREE, sample(1))
										
										select case as const world.location
										case 1
											'' FOREST 
											'' Destructable hit by a rocket
											if solid(i,j)=2 and (.a=2 or .a=9) then
												map(i,j)=2
												create_solid_map()
												FSOUND_PlaySound(FSOUND_FREE, sample(1))
											end if
											
											'' Omni Barrier
											if solid(i,j)=3 and .a=9 then
												map(i,j)=2
												create_solid_map()
												FSOUND_PlaySound(FSOUND_FREE, sample(1))
											end if
											
											'' Tree hit by rocket = fire!
											if map(i,j)=1 and (.a=2) then
												map(i,j)=7
												create_solid_map()
											end if
											
										case 2
											'' MOUNTAIN
											'' Lava hit by a freeze gun
											if solid(i,j)=2 and (.a=4 or .a=9) then
												map(i,j)=2	'' Turns into regular path...
												create_solid_map()
											end if
											
											'' Omni Barrier
											if solid(i,j)=3 and .a=9 then
												map(i,j)=2	'' Turns into regular path...
												create_solid_map()
												FSOUND_PlaySound(FSOUND_FREE, sample(1))
											end if
										case 3
											'' ICE
											'' Ice block hit by a heat gun
											'if solid(i,j)=2 and (.a=3 or .a=9) then
											'	map(i,j)=0
											'	create_solid_map()
											'end if
											
											'' Regular Ice hit by heat gun
											if map(i,j)=1 and (.a=3 or .a=9) then
												map(i,j)=0
												create_solid_map()
												FSOUND_PlaySound(FSOUND_FREE, sample(1))
											end if
											
											'' Omni Barrier
											if solid(i,j)=3 and .a=9 then
												map(i,j)=0
												create_solid_map()
												FSOUND_PlaySound(FSOUND_FREE, sample(1))
											end if
										case 4
											'' Lake
											'' Water hit by a freeze gun
											if solid(i,j)=2 and (.a=4 or .a=9) then
												map(i,j)=0
												create_solid_map()
											end if
											
											'' Tree hit by rocket = fire!
											if map(i,j)=1 and (.a=2) then
												map(i,j)=7
												create_solid_map()
											end if
											
											'' Omni Barrier
											if solid(i,j)=3 and .a=9 then
												map(i,j)=2	'' Grass
												create_solid_map()
												FSOUND_PlaySound(FSOUND_FREE, sample(1))
											end if
											
										case 5
											'' Desert
											'' Omni Barrier
											if solid(i,j)=3 and .a=9 then
												map(i,j)=2	'' Grass
												create_solid_map()
												FSOUND_PlaySound(FSOUND_FREE, sample(1))
											end if	
											
										end select
										
										.a=0
										
									end if
								end if
							
						end if
						
						''
					next i
				next j	
			end if
			
			if .a>0 then
				'' Hit enemy?
				for g as integer=0 to ubound(ghost)
					if ghost(g).a=1 then
						if ghost(g).contains(.x,.y)=1 then
							
							if player.has_armour=true then
								explo_add((ghost(g).x*32)+ghost(g).ox+8,(ghost(g).y*32)+ghost(g).oy+8)
								ghost(g).a=0
								FSOUND_PlaySound(FSOUND_FREE, sample(1))
							else
								' Stun enemy only (only happens on station)
								ghost(g).stun=200
							end if
							
							.a=0
							
						end if
					end if
				next g
			end if
			
		end with
	next i
	
end sub

sub shot_draw()
	dim as integer mx=(mymap.x*32)-mymap.ox
	dim as integer my=(mymap.y*32)-mymap.oy
	
	for i as integer=0 to ubound(shot)
		with shot(i)
			if .a=1 then put (.x-mx,.y-my),shot_spr(0),trans
			if .a=2 then put (.x-mx,.y-my),shot_spr(1),trans
			if .a=3 then put (.x-mx,.y-my),shot_spr(2),trans
			if .a=4 then put (.x-mx,.y-my),shot_spr(3),trans
			
			if .a=9 then put (.x-mx,.y-my),shot_spr(4),trans
		end with
	next i
end sub

sub shot_reset()
	for i as integer=0 to ubound(shot)
		shot(i).a=0
	next i
end sub

''
''
''

sub map_reset()
	player.reset()
	mymap.x=0'0
	mymap.y=0'0
	mymap.y=0'0
	mymap.ox=0
	mymap.oy=0	
	mission=1
	force_ext=0
	
	movedir=0
	
	explo_reset()
	shot_reset()
	enemy_shot_reset()
	world.reset()
	snow_set()
end sub


sub map_load_gfx(no as integer)

	dim map_names(5) as string=>{"station","forest","mountain","ice","lake","desert"}
	
	dim path as string="gfx\"+map_names(no)+"\"

	for i as integer=0 to ubound(sprite)
		sprite(i) = ImageCreate( 32, 32,rgb(100,255,100) )
	next i

	'' Scenery
    bload path+"space.bmp",sprite(0)
    bload path+"wall.bmp",sprite(1)
    bload path+"floor.bmp",sprite(2)

	'' Solid
	'bload path+"darkwall.bmp",sprite(3)

	bload path+"barrier.bmp",sprite(4)	'' E.g. Lava
    bload path+"star.bmp",sprite(5)
    bload path+"console.bmp",sprite(6) '' 
    bload path+"console2.bmp",sprite(7) ''  

	'' Collectable
	
	'bload "gfx\collect\scientist.bmp",sprite(9) ''cog
	
	select case as const no
	case 0
		'' Station
		bload "gfx\common\fire.bmp",sprite(3)
		bload path+"console.bmp",sprite(6) '' 
		bload path+"console2.bmp",sprite(7) ''  
		bload "gfx\collect\satellite.bmp",sprite(8) ''
		bload "gfx\collect\cog.bmp",sprite(9) ''
		bload "gfx\collect\armour.bmp",sprite(10) ''
		bload "gfx\collect\keycard.bmp",sprite(12) ''
		bload path+"console-info.bmp",sprite(13) ''
	case 1
		'' Forest
		bload "gfx\common\barrier.bmp",sprite(3)
		bload path+"console.bmp",sprite(6) '' 
		bload "gfx\common\fire.bmp",sprite(7) ''  
		bload "gfx\collect\diamond.bmp",sprite(8) ''
		bload "gfx\collect\scientist.bmp",sprite(9) ''
		bload "gfx\collect\rockets.bmp",sprite(10) ''
		bload "gfx\collect\satellite.bmp",sprite(12) ''
	case 2
		'' Mountain
		bload "gfx\common\barrier.bmp",sprite(3)
		bload "gfx\collect\diamond.bmp",sprite(8) ''
		bload "gfx\collect\scientist.bmp",sprite(9) ''
		bload "gfx\collect\heat.bmp",sprite(10) ''
		bload "gfx\collect\satellite.bmp",sprite(12) ''
	case 3
		'' Ice
		bload "gfx\common\barrier.bmp",sprite(3)
		bload "gfx\collect\diamond.bmp",sprite(8) ''
		bload "gfx\collect\scientist.bmp",sprite(9) ''
		bload "gfx\collect\freeze.bmp",sprite(10) ''
		bload "gfx\collect\satellite.bmp",sprite(12) ''
	case 4
		'' Lake
		bload "gfx\common\barrier.bmp",sprite(3)
		bload "gfx\common\fire.bmp",sprite(7) '' 
		bload "gfx\collect\diamond.bmp",sprite(8) ''
		bload "gfx\collect\scientist.bmp",sprite(9) ''
		bload "gfx\collect\freeze.bmp",sprite(10) ''
		bload "gfx\collect\satellite.bmp",sprite(12) ''
	case 5
		'' Desert
		bload "gfx\common\barrier.bmp",sprite(3)
		bload "gfx\collect\diamond.bmp",sprite(8) ''
		bload "gfx\collect\scientist.bmp",sprite(9) ''
		'bload "gfx\collect\satellite.bmp",sprite(10) ''
		bload "gfx\collect\satellite.bmp",sprite(12) ''
	end select

	if no=1 then
		sprite(11) = ImageCreate( 128, 32,rgb(100,255,100) ) '' tv	64x64
		bload path+"ship.bmp",sprite(11)
	else
		sprite(11) = ImageCreate( 64, 64,rgb(100,255,100) ) '' tv	64x64
		bload path+"tv.bmp",sprite(11)
	end if

	'' Enemy
    for i as integer=0 to ubound(enemy_spr)
		enemy_spr(i) = ImageCreate( 32, 32,rgb(100,255,100) )
	next i
	
	select case as const no
	case 2
		'' Mountain (turrets)
		bload "gfx\common\turret.bmp",enemy_spr(0) '' Up
		
	case 4,5
		'' Lake / Desert  Crabs (these will never get stunned by a shot)
		bload "gfx\common\crab1.bmp",enemy_spr(0) '' Up
		bload "gfx\common\crab2.bmp",enemy_spr(1) '' Right
		bload "gfx\common\crab3.bmp",enemy_spr(2) '' Down
		bload "gfx\common\crab4.bmp",enemy_spr(3) '' Left
		
	case else
		'' Standard Metal Tank
		bload "gfx\common\tank1.bmp",enemy_spr(0) '' Up
		bload "gfx\common\tank2.bmp",enemy_spr(1) '' Right
		bload "gfx\common\tank3.bmp",enemy_spr(2) '' Down
		bload "gfx\common\tank4.bmp",enemy_spr(3) '' Left
		''
		bload "gfx\common\stun-tank1.bmp",enemy_spr(4) '' Up
		bload "gfx\common\stun-tank2.bmp",enemy_spr(5) '' Right
		bload "gfx\common\stun-tank3.bmp",enemy_spr(6) '' Down
		bload "gfx\common\stun-tank4.bmp",enemy_spr(7) '' Left
		
	end select
	
	'' Portal
	for i as integer=0 to ubound(portal_spr)
		portal_spr(i) = ImageCreate( 32, 32,rgb(100,255,200) )
	next i
	
	bload "gfx\common\portal_0.bmp",portal_spr(0) ''
	bload "gfx\common\portal_1.bmp",portal_spr(1) ''
	bload "gfx\common\portal_2.bmp",portal_spr(2) ''
	bload "gfx\common\portal_3.bmp",portal_spr(3) ''
	
	'' Explosion
	explo_sprite = ImageCreate( 16, 16,rgb(100,255,100) )
	bload path+"explosion.bmp",explo_sprite
	
	tele_sprite = ImageCreate( 32, 32,rgb(100,255,100) )
	bload "gfx\common\teleport.bmp",tele_sprite
	
	snow_sprite = ImageCreate( 8, 8,rgb(100,255,100) )
	bload "gfx\common\flake.bmp",snow_sprite
	
	
    '' Player
    for i as integer=0 to ubound(player_spr)
		player_spr(i) = ImageCreate( 32, 32,rgb(100,255,100) )
	next i
	
	bload "gfx\player\up.bmp",player_spr(0)
	bload "gfx\player\up_1.bmp",player_spr(1)		

	bload "gfx\player\right.bmp",player_spr(2)
	bload "gfx\player\right_1.bmp",player_spr(3)
	
	bload "gfx\player\down.bmp",player_spr(4)
	bload "gfx\player\down_1.bmp",player_spr(5)	
	
	bload "gfx\player\left.bmp",player_spr(6)
	bload "gfx\player\left_1.bmp",player_spr(7)
	
	bload "gfx\player\arm_up.bmp",player_spr(10)
	bload "gfx\player\arm_up_1.bmp",player_spr(11)		

	bload "gfx\player\arm_right.bmp",player_spr(12)
	bload "gfx\player\arm_right_1.bmp",player_spr(13)
	
	bload "gfx\player\arm_down.bmp",player_spr(14)
	bload "gfx\player\arm_down_1.bmp",player_spr(15)	
	
	bload "gfx\player\arm_left.bmp",player_spr(16)
	bload "gfx\player\arm_left_1.bmp",player_spr(17)
	
	''
	for i as integer=0 to ubound(shot_spr)
		shot_spr(i) = ImageCreate( 8, 8,rgb(100,255,100) )
	next i
	bload "gfx\player\shot.bmp",shot_spr(0)
	bload "gfx\player\rocket.bmp",shot_spr(1)
	bload "gfx\player\heat.bmp",shot_spr(2)
	bload "gfx\player\freeze.bmp",shot_spr(3)
	bload "gfx\player\omni.bmp",shot_spr(4)
	
	
	'' Likely moving to new area so reset everything
	explo_reset()
	shot_reset()
	enemy_shot_reset()
end sub


'' Separate as we will recreate if we remove a block
sub create_solid_map()
	dim as integer i,j
	
	'' Clear
	for j=0 to mapheight-1
		for i=0 to mapwidth-1
			solid(i,j)=0 
		next i
	next j

	'' Create solid map
	for j=0 to mapheight-1
		for i=0 to mapwidth-1		
			
			if (map(i,j)=1) then solid(i,j)=1 '' Wall / Tree	

			if (map(i,j)=3) then solid(i,j)=3 '' Fire / OmniBarrier
			
			if (map(i,j)=4) then solid(i,j)=2 '' Barrier / Rocks
			
			if (map(i,j)=6 or map(i,j)=7) then solid(i,j)=1 '' Consoles
			if (map(i,j)=13) then solid(i,j)=1 				'' Info Console
			
			if (map(i,j)=11) then 
				solid(i,j)=11 	'' Ship / tv
				solid(i+1,j)=11 '' Ship / tv
				
				if world.location>0 then
					solid(i+2,j)=11 '' Ship
					solid(i+3,j)=11	'' Ship
				end if
			
			end if
			
		next i
	next j		
end sub


sub map_flip()
	dim as integer i,j
	dim temp(mapwidth*mapheight) as ubyte 

	'' copy
	for i=0 to ubound(temp)
		temp(i)=basemap(i)
	next i
	
	'' flip row by row..
	dim as integer c=0
	for j=0 to mapheight-1
		for i=0 to mapwidth-1
			basemap(c+i)=temp((mapwidth*( (mapheight-1)-j))+i)  '' 32*(31-j)
		next i
		c+=mapwidth	''32
	next j
end sub

'' Use this to find out if station on fire!
function map_contains(no as integer) as boolean
	dim as boolean result=false

		for j as integer=0 to mapheight-1
			for i as integer=0 to mapwidth-1
				if map(i,j)=no then return true
			next i
			
		next j

	return false
end function



sub add_enemys()
	dim as integer c=0
	while 1
		dim as integer tx=2+int(rnd*28) ' 2+int(rnd*28)
		dim as integer ty=2+int(rnd*28) ' 2+int(rnd*28)
		
		if map(tx,ty)=2 then
			ghost(c).a=1
			ghost(c).x=tx
			ghost(c).y=ty
			c=c+1
			if c>ubound(ghost) then exit while
		end if
	wend
	
	for g as integer=0 to ubound(ghost)
		with ghost(g)
			.ox=0
			.oy=0
			.xdir=1
			.ydir=0
			.visible=0
			.spawn=200+int(rnd*100) '10*30
			.stun=0
			.firedelay=200+int(rnd*100)
		end with
	next g	
end sub

sub no_enemys()
	for g as integer=0 to ubound(ghost)
		ghost(g).a=0
	next g	
end sub


sub map_load_all()
	dim header as bmphdr

	dim map_names(5) as string=>{"station","forest","mountain","ice","lake","desert"}

	const path as string="maps\"

	for n as integer=0 to ubound(map_names)
		if  Open(path+map_names(n)+".bmp" For binary access read As #1)=0 then
			get #1,,header	
			get #1,header.offset+1,basemap()  
			Close #1     
					  
			mapwidth=header.w
			mapheight=header.h      
					  
			map_flip()  
				
			'' Copy map
			dim as integer c=0
			for j as integer=0 to mapheight-1
				for i as integer=0 to mapwidth-1
					select case as const n
					case 0:
						station(i,j).sprite=basemap(c)
						station(i,j).visible=1
					case 1: 
						forest(i,j).sprite=basemap(c)
						forest(i,j).visible=1
					case 2: 
						'if basemap(c)=0 then basemap(c)=-1
						mountain(i,j).sprite=basemap(c)
						mountain(i,j).visible=0
					case 3: 
						ice(i,j).sprite=basemap(c)
						ice(i,j).visible=1
					case 4: 
						lake(i,j).sprite=basemap(c)
						lake(i,j).visible=1	
					case 5: 
						desert(i,j).sprite=basemap(c)
						desert(i,j).visible=1	
					end select
					c+=1
				next i
			next j
			
		else
			print "Could not load map "+map_names(n)
			draw string(8,128+(n*32)),"Could not load map "+map_names(n)
			sleep 100*10 
		end if
	next n
	
end sub

sub map_save()
	for j as integer=0 to mapheight-1
		for i as integer=0 to mapwidth-1
			select case as const world.location 'current_map
			case 0:
				station(i,j).sprite=map(i,j)
				station(i,j).visible=visible(i,j)
			case 1:
				forest(i,j).sprite=map(i,j)
				forest(i,j).visible=visible(i,j)
			case 2:
				mountain(i,j).sprite=map(i,j)
				mountain(i,j).visible=visible(i,j)
			case 3: 
				ice(i,j).sprite=map(i,j)
				ice(i,j).visible=visible(i,j)
			case 4: 
				lake(i,j).sprite=map(i,j)
				lake(i,j).visible=visible(i,j)
			case 5: 
				desert(i,j).sprite=map(i,j)
				desert(i,j).visible=visible(i,j)
			end select
		next i
	next j
end sub

sub map_load(no as integer)

	for j as integer=0 to mapheight-1
		for i as integer=0 to mapwidth-1
			select case as const no
			case 0
				'' Station
				map(i,j)=station(i,j).sprite
				visible(i,j)=station(i,j).visible
			case 1
				'' Forest
				map(i,j)=forest(i,j).sprite
				visible(i,j)=forest(i,j).visible
			case 2
				'' Mountain
				map(i,j)=mountain(i,j).sprite
				visible(i,j)=mountain(i,j).visible
			case 3
				'' Arctic
				map(i,j)=ice(i,j).sprite
				visible(i,j)=ice(i,j).visible	
			case 4
				'' Lake
				map(i,j)=lake(i,j).sprite
				visible(i,j)=lake(i,j).visible
			case 5
				'' Desert
				map(i,j)=desert(i,j).sprite
				visible(i,j)=desert(i,j).visible
				
			end select
		next i
	next j
		
	no_enemys()

	add_enemys()
	
	create_solid_map()

	map_load_gfx(no)

end sub

sub draw_enemys()
	for g as integer=0 to ubound(ghost)
		
		with ghost(g)
			if .a=1 and .visible=1 then
				dim as integer gx=((.x-mymap.x) *32)+(mymap.ox+.ox) 
				dim as integer gy=((.y-mymap.y) *32)+(mymap.oy+.oy) 
				
				if .spawn>0 then
					'' Show portal where enemy will appear from
					put (gx,gy),portal_spr(portal_frame),trans
				else
					
					if .stun=0 then
					
						if world.location=2 then
							'' Fixed turret
							put (gx,gy),enemy_spr(0),trans
						else
						
							'' Show actual enemy (not frozen)
							if .xdir=0 then
								if .ydir=-1 then put (gx,gy),enemy_spr(0),trans
								if .ydir=1 then put (gx,gy),enemy_spr(2),trans
							else
								if .xdir=1 then put (gx,gy),enemy_spr(1),trans
								if .xdir=-1 then put (gx,gy),enemy_spr(3),trans
							end if
						end if
					else
						if world.location=2 then
							'' Fixed turret
							put (gx,gy),enemy_spr(0),trans
						else
							if .xdir=0 then
								if .ydir=-1 then put (gx,gy),enemy_spr(4),trans
								if .ydir=1 then put (gx,gy),enemy_spr(6),trans
							else
								if .xdir=1 then put (gx,gy),enemy_spr(5),trans
								if .xdir=-1 then put (gx,gy),enemy_spr(7),trans
							end if
						end if
					'	draw stunned sprites here!
					end if
				end if
			end if
		end with
	next g	
	
end sub

''
''
''

dim shared order(3) as integer => {1,2,3,4}

sub jumble()
	
	'' Jumble directions
	dim as integer a,b,c
	for i as integer=0 to 20
		a=int(rnd*4)
		b=int(rnd*4)
		
		c=order(a)
		order(a)=order(b)
		order(b)=c
	next i

end sub

sub update_enemys()
	for g as integer=0 to ubound(ghost)
		
		with ghost(g)
		
			if .spawn>0 then
				if visible(.x,.y)=1 then .visible=1 else .visible=0
				.spawn-=1
				continue for
			end if
		
			if .a>0 then
				if .stun>0 then
					if visible(.x,.y)=1 then .visible=1 else .visible=0
					.stun-=1
					continue for
				end if
			
				if .ox=0 and .oy=0 then
					if visible(.x,.y)=1 then .visible=1 else .visible=0
					'' Choose a clear direction
					dim as boolean choose=false
					
					'' Hit a wall going in current direction?
					if (.x+.xdir>=0) and (.y+.ydir>=0) then
						if (.x+.xdir<=31) and (.y+.ydir<=31) then
							if solid(.x+.xdir,.y+.ydir)>0 then choose=true
						else
							choose=true
						end if
					else
						'' If chance of leaving the map, change direction
						choose=true
					end if
					
					'' Skip next bit if mountain turret
					if world.location=2 then choose=false
					
					if choose=true then
						.xdir=0
						.ydir=0
						
						jumble()
						
						for i as integer=0 to ubound(order)
						
							select case as const order(i)
							case 1
								if (.y-1)>=0 then
									if solid(.x,.y-1)=0 then .ydir=-1
								end if
							case 2
								if (.x+1)<=31 then
									if solid(.x+1,.y)=0 then .xdir=1
								end if
							case 3
								if (.y+1)<=31 then
									if solid(.x,.y+1)=0 then .ydir=1
								end if
							case 4
								if (.x-1)>=0 then
									if solid(.x-1,.y)=0 then .xdir=-1
								end if
							end select
							
							if (.xdir<>0) or (.ydir<>0) then exit for
						next i
					end if
					
					' Fire a shot
					if world.location<>2 then 
						if (rnd*10)>8 then
							dim as integer gx=((.x-mymap.x) *32)+(mymap.ox+.ox) 
							dim as integer gy=((.y-mymap.y) *32)+(mymap.oy+.oy) 
			
							enemy_shot_add(gx,gy,.xdir,.ydir,1)
						end if
					end if
									
				end if
				
				'' Enemy collided with player??
				if (.x-mymap.x=player.x) and (.y-mymap.y=player.y) then
					.a=0
					player.health-=1
					explo_add((.x*32)+.ox, (.y*32)+.oy)
					FSOUND_PlaySound(FSOUND_FREE, sample(1))
				end if
				
				'' Do not move if stunned		
				if world.location<>2 then
					.ox+=.xdir
					.oy+=.ydir
					
					if (.ox=32 or .ox=-32) then
						.x+=.xdir	
						.ox=0
					end if

					if (.oy=32 or .oy=-32) then
						.y+=.ydir
						.oy=0
					end if
				else
					if visible(.x,.y)=1 then 
						.visible=1 
					
						if .firedelay=0 then
							' Fire a shot (Turret)
							if (rnd*10)>8 then
								'' Screen x,y
								dim as integer gx=((.x-mymap.x) *32)+(mymap.ox+.ox) 
								dim as integer gy=((.y-mymap.y) *32)+(mymap.oy+.oy) 
				
								.xdir=0
								if (player.x*32)+player.ox<gx then .xdir=-1
								if (player.x*32)+player.ox>gx then .xdir=1
				
								.ydir=0
								if (player.y*32)+player.oy<gy then .ydir=-1
								if (player.y*32)+player.oy>gy then .ydir=1
				
								enemy_shot_add(gx,gy,.xdir,.ydir,1)
								.firedelay=200+int(rnd*100)
							end if
						else
							.firedelay-=1
						end if
					
					else
						.visible=0
					end if
					
				end if
			end if
		end with
	
	next g	
end sub




sub hud()

	'world.show()

	color rgb(255,255,0)
	
	dim gtxt as string
	'' guage
	
	if player.has_omni=true then
		if player.omni>10 then 
			gtxt="[##########]"
		else
			gtxt="[..........]"
			for i as integer=0 to player.omni-1
				gtxt[1+i]=asc("#")
			next i
		end if
		
		color rgb(0,0,0)
		draw string(10+1,462+1),"[X] OmniBlaster "+gtxt

		color rgb(255,255,0)
		draw string(10,462),"[X] OmniBlaster "+gtxt
		
	else
	
		if player.has_rockets=true then
			if player.rockets>5 then 
				gtxt="[#####]"
			else
				gtxt="[.....]"
				for i as integer=0 to player.rockets-1
					gtxt[1+i]=asc("#")
				next i
			end if
			
			color rgb(0,0,0)
			draw string(10+1,462+1),"[X] Rockets "+gtxt

			color rgb(255,255,0)
			draw string(10,462),"[X] Rockets "+gtxt
			
		end if
		''
		if player.has_heat=true then
			if player.heat>5 then 
				gtxt="[#####]"
			else
				gtxt="[.....]"
				for i as integer=0 to player.heat-1
					gtxt[1+i]=asc("#")
				next i
			end if
			
			color rgb(0,0,0)
			draw string(210+1,462+1),"[C] Heat "+gtxt
			
			color rgb(255,255,0)
			draw string(210,462),"[C] Heat "+gtxt	
		end if
		
	
		if player.has_freeze=true then
			if player.freeze>5 then 
				gtxt="[#####]"
			else
				gtxt="[.....]"
				for i as integer=0 to player.freeze-1
					gtxt[1+i]=asc("#")
				next i
			end if
			
			color rgb(0,0,0)
			draw string(410+1,462+1),"[V] Cold "+gtxt 
			
			color rgb(255,255,0)
			draw string(410,462),"[V] Cold "+gtxt 
		end if
	''
	end if
	
	'' Diamonds
	for c as integer=0 to player.diamond-1
		color rgb(0,0,0)
		draw string(640-12-(12*c)+1,442+1),chr(4)
		
		color rgb(255,255,0)
		draw string(640-12-(12*c),442),chr(4)
	next
	
	'' Scientist
	if player.hostages_rescued=false then
		for c as integer=0 to player.hostages-1
			color rgb(0,0,0)
			draw string(640-12-(12*c)+1,462+1),"*"
			color rgb(255,255,0)
			draw string(640-12-(12*c),462),"*"
		next
	else
		for c as integer=0 to player.sat-1
			color rgb(0,0,0)
			draw string(640-12-(12*c)+1,462+1),"S"
			color rgb(255,255,0)
			draw string(640-12-(12*c),462),"S"
		next
	end if
	

	'' Health
	if player.has_armour=true then
		'' Health
		if player.health>10 then 
			gtxt="[##########]"
		else
			gtxt="[..........]"
			for i as integer=0 to player.health-1
				gtxt[1+i]=asc("#")
			next i
		end if
	
	
		if player.has_rockets=true or player.has_omni=true then
			color rgb(0,0,0)	
			draw string(10+1,442+1),"Armour "+gtxt 
			color rgb(255,255,0)
			draw string(10,442),"Armour "+gtxt 
		else
			color rgb(0,0,0)	
			draw string(10+1,462+1),"Armour "+gtxt 
			color rgb(255,255,0)
			draw string(10,462),"Armour "+gtxt 
		end if
	else
	'' Health
		if player.health>5 then 
			gtxt="[#####]"
		else
			gtxt="[.....]"
			for i as integer=0 to player.health-1
				gtxt[1+i]=asc("#")
			next i
		end if
	
		color rgb(0,0,0)	
		draw string(10+1,462+1),"Health "+gtxt 
		color rgb(255,255,0)
		draw string(10,462),"Health "+gtxt 
	end if
	
end sub

sub map_drawonly(show_player as boolean)
	dim as integer x,y
	dim as integer sx,sy,tile
	dim as integer ax,ay
	
	'cls 
	fastcls()
	
	'' Grass, floor
	for y=-1 to 15
		sy=(y*32)+mymap.oy	
		for x=-1 to 20	
			if 	(mymap.x+x>=0) and (mymap.y+y>=0) then			
				sx=(x*32)+mymap.ox
				
				ax=mymap.x+x
				ay=mymap.y+y

				if visible(ax,ay)=1 then
					tile=map(ax,ay)
					
					'' TV 
					if tile=11 then tile=2	'' Floor
					
					'' Fire (floor under)
					if tile=3 then tile=2	'' Floor
					if tile=7 then tile=2	'' Floor
					
					'' Collectables (rocket/freeze)
					if tile=8 or tile=9 or tile=10 or tile=12 then 
						tile=map(mymap.x+x+1,mymap.y+y)	'' Next tile
					end if
					
					'' Mountain
					if world.location=2 and tile=0 then tile=-1
					
					if tile=0 or tile=2 or tile=5 or tile=4 then put (sx,sy),sprite(tile),pset	
				end if
				
			end if
		next x
	next y
	
	'' Wall shadow in mountain area 
	if world.location=2 then
		for y=-1 to 15
			sy=(y*32)+mymap.oy	
			for x=-1 to 20	
				if 	(mymap.x+x>=0) and (mymap.y+y>=0) then			
					sx=(x*32)+mymap.ox
						
					ax=mymap.x+x
					ay=mymap.y+y

					if visible(ax,ay)=1 then
						tile=map(ax,ay)
						if tile=1 then put (sx,sy+16),sprite(0),pset
					end if
				end if
			next x
		next y
	end if


	
	'' Walls
	for y=-1 to 15
		sy=(y*32)+mymap.oy	
		for x=-1 to 20	
			if 	(mymap.x+x>=0) and (mymap.y+y>=0) then			
				sx=(x*32)+mymap.ox
					
				ax=mymap.x+x
				ay=mymap.y+y

				if visible(ax,ay)=1 then
					tile=map(ax,ay)
					if tile=1 then put (sx,sy),sprite(tile),pset
				end if
			end if
		next x
	next y

			
	'' Everything else!
	dim as integer trs=0
	'dim as boolean skip=false
	
	for y=-2 to 15
		sy=(y*32)+mymap.oy
		for x=-1 to 20		
			if 	(mymap.x+x>=0) and (mymap.y+y>=0) then	

				ax=mymap.x+x
				ay=mymap.y+y
				
				if visible(ax,ay)=1 then
					tile=map(ax,ay)	
					
					'' Skip Lava/Barrier and draw above
					if tile=4 then tile=-1					
						
					if tile>=3 then 
						trs=0
						sx=(x*32)+mymap.ox
						
						'' Cooker / Cupboard / TV
						if (tile=8 or tile=9) then trs=1
			
						'' Collectables
						if tile=10 then trs=1
						if tile=12 then trs=1	'' Keycard
						
						'' Fire
						if tile=3 then trs=1	'' Floor			
						if tile=7 then trs=1	'' Forest fire
						
						'' TV 
						if tile=11 then
						
							if world.location=1 then
								'' Ship
								put (sx,sy),sprite(tile),trans
							else
								'' Monitor
								put (sx,sy),sprite(tile),(0,32)-(64,64),trans
							end if
							'' Don't bother with the rest of the loop...
							
							continue for
						end if
					
						if trs=0 then
							put (sx,sy),sprite(tile),pset
						else
							put (sx,sy),sprite(tile),trans
						end if
						
					end if
				end if
			end if
		next x
	next y
	
	if show_player=true then
		put ((player.x*32)+player.ox,(player.y*32)+player.oy),player_spr(player.spr_offset+player.f+alt),trans
	end if
	
	draw_enemys()	
	display_message()
	shot_draw()
	enemy_shot_draw()
	explo_draw()	
	tele_draw()	
	
	'' Snow in Ice area
	if world.location=3 then snow_draw()	

end sub

sub map_draw()

	'' Draw map and player!
	map_drawonly(true)
	
	'' End of drawing?
	
	update_enemys()
	shot_update()
	enemy_shot_update()
	
	'' Snow in Ice area
	if world.location=3 then snow_update()	
	
	if player.firedelay>0 then player.firedelay-=1
	
	if player.ox=0 and player.oy=0 then
		dim as integer x,y 
		dim as integer ax,ay 
		
		'' Make visible around player
		for y=0 to 8 ''4
			for x=0 to 8
				ax=player.x+mymap.x-4+x
				ay=player.y+mymap.y-4+y
				if ax>=0 and ax<=31 then
					if ay>=0 and ay<=31 then
						visible(ax,ay)=1
					end if
				end if
			next x
		next y
	
			'' Information AVAILABLE (press space to find out more...)
		
		dim as integer looking_at=-1
		
		if (player.x+mymap.x+player.xdir>=0) and (player.y+mymap.y+player.ydir>=0) then
			looking_at=map(player.x+mymap.x+player.xdir,player.y+mymap.y+player.ydir)
		end if
		
		dim as boolean info_available=false
			
		select case as const world.location
			case 0
				if player.has_armour=true then
					if player.x+mymap.x=25 and player.y+mymap.y>=22 then
						
						if map_contains(3)=false then
							'' Remove SOME barriers (to let out any trapped monsters)
							for y as integer=0 to 31
								for x as integer=12 to 31
									if map(x,y)=4 then map(x,y)=map(x+1,y)
								next x
							next y
							
							'' Add fire to force player path
							dim as integer tx,ty
							for i as integer=0 to 50
								tx=2+int(rnd*28) 
								ty=int(rnd*17)  
								
								if map(tx,ty)=2 then map(tx,ty)=3
							next i
							'' Fire bar
							for i as integer=0 to 31
								if map(i,17)=2 then map(i,17)=3
							next i
							
							'' As just added fire
							create_solid_map()
							
							force_ext=90+15
						end if
					end if
				end if
					
				
			case 1
				if looking_at=3 then info_available=true	'' Crystal Barrier
				
				if looking_at=4 then info_available=true	'' Regular Boulder
				
				if looking_at=11 then info_available=true	'' Ship
				
				dim as integer solid_at=-1
				
				if (player.x+mymap.x+player.xdir>=0) and (player.y+mymap.y+player.ydir>=0) then
					solid_at=solid(player.x+mymap.x+player.xdir,player.y+mymap.y+player.ydir)
				end if
				
				if solid_at=11 then info_available=true		'' Ship (wide sprite)
				
			case 2
				if looking_at=3 then info_available=true	'' Unstable Barrier
				if looking_at=4 then info_available=true	'' Lava
				
			case 3
				if looking_at=3 then info_available=true	'' Unstable Barrier
				if looking_at=1 then info_available=true	'' Regular Ice block
			
			case 4
				'' Lake
				if looking_at=3 then info_available=true	'' Unstable Barrier
			case 5
				'' Desert
				if looking_at=3 then info_available=true	'' Unstable Barrier
		end select
			
		dim as string comment=""
		if info_available=true then comment="Information Available - Press Space"
		
		'' Information (something has happened)
		
			
		if (player.y+mymap.y-1)>=0 and (player.y+mymap.y-1)<=31 and (player.x+mymap.x)>=0 and (player.x+mymap.x)<=31 then	
			' Use
			if player.has_keycard=true then
				if map(player.x+mymap.x,player.y+mymap.y-1)=6 then comment="Teleport controls! Press Space to log in!"
				if map(player.x+mymap.x,player.y+mymap.y-1)=7 then comment="Barrier controls! Press Space to log in!"
				if map(player.x+mymap.x,player.y+mymap.y-1)=13 then comment="Information Console! Press Space to log in!"
			else
				if map(player.x+mymap.x,player.y+mymap.y-1)=6 then comment="Teleport controls! Access Keycard Required!"
				if map(player.x+mymap.x,player.y+mymap.y-1)=7 then comment="Barrier controls! Access Keycard Required!"
				if map(player.x+mymap.x,player.y+mymap.y-1)=13 then comment="Information Console! Access Keycard Required!"
			end if
		
			' Collect
			if map(player.x+mymap.x,player.y+mymap.y)=8 then 
				'' Diamond
				map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
				set_message("Power Diamond collected!")
				player.diamond+=1
				FSOUND_PlaySound(FSOUND_FREE, sample(2))
				
				if player.diamond=10 then
					set_message("10 diamonds collected! Return to your ship for more information!")
				else
					set_message("Power Diamond collected!")
				end if
			end if
			
			select case as const world.location
			case 0
				'' SPACE STATION
				if map(player.x+mymap.x,player.y+mymap.y)=10 then 
					'' Armour
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					
					set_message("Modulus Armour collected!")
					force_ext=98	'' Collected Armour
					
					player.has_armour=true
					player.spr_offset=10
					player.health=10
					FSOUND_PlaySound(FSOUND_FREE, sample(2))
				end if
			
				if map(player.x+mymap.x,player.y+mymap.y)=9 then 
					'' Cog
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					set_message("Omni Cog collected!")
					force_ext=97	'' Omnicog message
					cog+=1
					FSOUND_PlaySound(FSOUND_FREE, sample(2))
				end if
				
				if map(player.x+mymap.x,player.y+mymap.y)=12 then 
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					set_message("Access Keycard collected!")
					''force_ext=97	'' Omnicog message
					player.has_keycard=true
					FSOUND_PlaySound(FSOUND_FREE, sample(2))
				end if
				
			case 1
				'' FOREST
				if map(player.x+mymap.x,player.y+mymap.y)=10 then 
					'' Rockets
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					player.rockets+=5
					
					set_message("Rockets collected! Press X to launch!")
					player.has_rockets=true
					FSOUND_PlaySound(FSOUND_FREE, sample(2))
				end if
			
				if map(player.x+mymap.x,player.y+mymap.y)=9 then 
					'' Cog
					if player.has_teleport=true then
						map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
						set_message("Scientist Rescued!")
						
						tele_add( (player.x+mymap.x)*32, (player.y+mymap.y)*32)
						
						FSOUND_PlaySound(FSOUND_FREE, sample(3))	'' Was 2
						
						player.hostages+=1
						if player.hostages=1 then force_ext=90+17	'' One Rescued
						if player.hostages>=4 then 
							'force_ext=90+12	'' All Rescued
							player.hostages_rescued=true
							set_message("All scientists rescued! Return to your ship for more information!")
						end if
					else
						set_message("Ship Teleporter Offline - Unable to retrieve target!")
					end if
				end if
				
				if map(player.x+mymap.x,player.y+mymap.y)=12 then 
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					set_message("Satellite recovered")
					tele_add( (player.x+mymap.x)*32, (player.y+mymap.y)*32)
					player.sat+=1
					FSOUND_PlaySound(FSOUND_FREE, sample(3))
				end if
			
			case 2
				'' MOUNTAIN
				if map(player.x+mymap.x,player.y+mymap.y)=10 then 
					'' Heat
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					player.heat+=5
					set_message("Heat Shots collected! Press C to launch!")
					player.has_heat=true
					FSOUND_PlaySound(FSOUND_FREE, sample(2))
				end if
				
				if map(player.x+mymap.x,player.y+mymap.y)=9 then 
					'' Cog
					if player.has_teleport=true then
						map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
						set_message("Scientist Rescued!")
						tele_add( (player.x+mymap.x)*32, (player.y+mymap.y)*32)
						
						player.hostages+=1
						if player.hostages=1 then force_ext=90+17	'' One Rescued
						if player.hostages>=4 then 
							'force_ext=90+12	'' All Rescued
							player.hostages_rescued=true
							set_message("All scientists rescued! Return to your ship for more information!")
						end if
						FSOUND_PlaySound(FSOUND_FREE, sample(3))
					else
						set_message("Ship Teleporter Offline - Unable to retrieve target!")
					end if
				end if
				
				if map(player.x+mymap.x,player.y+mymap.y)=12 then 
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					set_message("Satellite recovered")
					tele_add( (player.x+mymap.x)*32, (player.y+mymap.y)*32)
					player.sat+=1
					FSOUND_PlaySound(FSOUND_FREE, sample(3))
				end if
				
			case 3
				'' ICE AREA
				if map(player.x+mymap.x,player.y+mymap.y)=10 then 
					'' Freeze
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					player.freeze+=5
					set_message("Freeze Shots collected! Press V to launch!")
					player.has_freeze=true
					FSOUND_PlaySound(FSOUND_FREE, sample(2))
				end if
				
				if map(player.x+mymap.x,player.y+mymap.y)=9 then 
					'' Cog
					if player.has_teleport=true then
						map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
						set_message("Scientist Rescued!")
						tele_add( (player.x+mymap.x)*32, (player.y+mymap.y)*32)
						
						player.hostages+=1
						
						if player.hostages=1 then force_ext=90+17	'' One Rescued
						if player.hostages>=4 then 
							'force_ext=90+12	'' All Rescued
							player.hostages_rescued=true
							set_message("All scientists rescued! Return to your ship for more information!")
						end if
						FSOUND_PlaySound(FSOUND_FREE, sample(3))
					else
						set_message("Ship Teleporter Offline - Unable to retrieve target!")
					end if
				end if
				
				if map(player.x+mymap.x,player.y+mymap.y)=12 then 
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					
					tele_add( (player.x+mymap.x)*32, (player.y+mymap.y)*32)
					player.sat+=1
					FSOUND_PlaySound(FSOUND_FREE, sample(3))
					
					if player.sat=4 then
						set_message("All satellites recovered! Return to your ship!")
					else
						set_message("Satellite recovered")
					end if
					
				end if
				
			case 4
				'' Lake
				if map(player.x+mymap.x,player.y+mymap.y)=9 then 
					'' Cog
					if player.has_teleport=true then
						map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
						set_message("Scientist Rescued!")
						tele_add( (player.x+mymap.x)*32, (player.y+mymap.y)*32)
						
						player.hostages+=1
						if player.hostages=1 then force_ext=90+17	'' One Rescued
						if player.hostages=4 then 
							'force_ext=90+12	'' All Rescued
							player.hostages_rescued=true
							set_message("All scientists rescued! Return to your ship for more information!")
						end if
						FSOUND_PlaySound(FSOUND_FREE, sample(3))
					else
						set_message("Ship Teleporter Offline - Unable to retrieve target!")
					end if
				end if	
			
				if map(player.x+mymap.x,player.y+mymap.y)=12 then 
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					set_message("Satellite recovered")
					tele_add( (player.x+mymap.x)*32, (player.y+mymap.y)*32)
					player.sat+=1
					FSOUND_PlaySound(FSOUND_FREE, sample(3))
					
					if player.sat=4 then
						set_message("All satellites recovered! Return to your ship!")
					else
						set_message("Satellite recovered")
					end if
				end if
			
			case 5
				'' Desert
				if map(player.x+mymap.x,player.y+mymap.y)=12 then 
					map(player.x+mymap.x,player.y+mymap.y)=map(player.x+mymap.x+1,player.y+mymap.y)
					set_message("Satellite recovered")
					tele_add( (player.x+mymap.x)*32, (player.y+mymap.y)*32)
					player.sat+=1
					FSOUND_PlaySound(FSOUND_FREE, sample(3))
					
					if player.sat=4 then
						set_message("All satellites recovered! Return to your ship!")
					else
						set_message("Satellite recovered")
					end if
					
				end if
			end select
			
		end if
		
		if len(comment)>0 then
			color rgb(255,255,255)	
			infobar(comment)
		end if
					
	end if
	
	hud()
		
	if player.health<=0 then force_ext=90+21	
	
	'color rgb(255,255,255)
	'draw string(20,10),"MX:"+str(mymap.x)
	'draw string(20,20),"MY:"+str(mymap.y)
	'draw string(20,30),"MoX:"+str(mymap.ox)
	'draw string(20,40),"MoY:"+str(mymap.oy)
	
	'draw string(100,10),"PX:"+str(player.x)
	'draw string(100,20),"PY:"+str(player.y)
	'draw string(100,30),"PoX:"+str(player.ox)
	'draw string(100,40),"PoY:"+str(player.oy)
	
'	draw string(64,64),str(mymap.x)+" , "+str(mymap.y)
'	draw string(64,96),str(player.x)+" , "+str(player.y)
	
'	bg_fc+=1
'	if bg_fc>=30 then
'		bg_fc=0
'		bg_alt=1-bg_alt
'	end if
	
end sub



dim shared as integer tick

sub map_update()
	const as integer spd=2
	
	select case as const movedir
	case 1	
		'' up
		if mymap.y>0 and player.y<4then
			mymap.oy+=spd
			if mymap.oy=32 then 
				mymap.oy=0
				mymap.y-=1
				movedir=0
			end if
		else		
			player.oy-=spd
			if player.oy=-32 then 
				player.oy=0
				player.y-=1
				movedir=0
				
				'if player.y=-1 then
				'	map_load(2)	'' Forest to Ice
				'	player.oy=0
				'	player.y=14
				
				'	mymap.oy=0
				'	mymap.y=17
				'end if
				
			end if
		end if
		
	case 2
		'' Right
		if mymap.x<12 and player.x>15 then
			mymap.ox-=spd
			if mymap.ox=-32 then 
				mymap.ox=0
				mymap.x+=1
				movedir=0
			end if
		else
			player.ox+=spd
			if player.ox=32 then 
				player.ox=0
				player.x+=1
				movedir=0
			end if
		end if	
	case 3
		'' Down
		if mymap.y<17 and player.y>10 then
			mymap.oy-=spd
			if mymap.oy=-32 then 
				mymap.oy=0
				mymap.y+=1
				movedir=0
				
			end if
		else		
			player.oy+=spd
			if player.oy=32 then 
				player.oy=0
				player.y+=1
				movedir=0
				
				'if player.y=14 then
				'	map_load(1)	'' Ice to Forest
				'	player.oy=0
				'	player.y=1
					
				'	mymap.oy=0
				'	mymap.y=0
				'end if
			end if
		end if
	case 4
		'' Left
		if mymap.x>0 and player.x<4 then
			mymap.ox+=spd
			if mymap.ox=32 then 
				mymap.ox=0
				mymap.x-=1
				movedir=0
			end if
		else	
			player.ox-=spd
			if player.ox=-32 then 
				player.ox=0
				player.x-=1
				movedir=0
			end if
		end if
		
	end select

	if movedir>=1 and movedir<=4 then 
		fc+=1
		if fc=4 then
			fc=0
			alt=1-alt
		end if
	end if
	
	if movedir<0 then
		movedir+=1
	end if
	
	''
	tick+=1
	
	if (tick mod 10)=0 then 
		portal_frame+=1
		if portal_frame>ubound(portal_spr) then portal_frame=0
	end if
	
	
	if (tick>30*10) then
		tick=0
		'' Slowly recharge weapons
		if (player.has_heat=true) and (player.heat<5) then player.heat+=1
		if (player.has_freeze=true) and(player.freeze<5) then player.freeze+=1
		if (player.has_omni=true) and(player.omni<10) then player.omni+=1
	end if
	
end sub

function map_controls() as integer
	dim as integer ext=0
	
	if force_ext>0 then 
		ext=force_ext
		force_ext=0
		return ext
	end if
		
	
	'' Quit entirely if we click the window X button
	if inkey=Chr(255)&"k" then ext=CLOSEGAME
	
	'' Escape to welcome screen
	if  MultiKey(SC_ESCAPE) then esc=1
	if  MultiKey(SC_ESCAPE)=0 and esc=1 then
		esc=0
		ext=EXITGAME 'QUIT
	end if

	''	
	if movedir=0 then
		if  MultiKey(SC_UP) then 
			
			if player.f=0 then
				'' Move if we are facing the direction
				if player.y=0 and mymap.y=0 then
					map_save()
					
					world.move(0,-1)
					map_load(world.location)
					
					player.oy=0
					player.y=15	''14
					player.ydir=-1 '0
					mymap.oy=0
					mymap.y=17
					movedir=1
				else
					if solid(mymap.x+player.x,mymap.y+player.y-1)=0 then 
						movedir=1
					end if
				end if
			else
				'' Change facing direction but do not move!
				player.f=0
				player.xdir=0
				player.ydir=-1
				movedir=-4	'' Add slight delay when changing direction
			end if
			
		end if
		
		if  MultiKey(SC_RIGHT) then 
			if player.f=2 then
			
				''if player.x=31 and mymap.x=0 then
				if (player.x+mymap.x)=31 then
					map_save()
					'map_load(3)	'' Mountain to Ice
					
					world.move(1,0)
					map_load(world.location)
					
					player.ox=0
					player.x=-1	'0	''14
					
					player.xdir=1 '0
					mymap.ox=0
					mymap.x=0'-1
					movedir=2
				else
					if solid(mymap.x+player.x+1,mymap.y+player.y)=0 then
						movedir=2
					end if
				end if
				
			else
				player.f=2
				player.xdir=1
				player.ydir=0
				movedir=-4	'' Add slight delay when changing direction
			end if
		end if
		
		if  MultiKey(SC_DOWN) then 
			if player.f=4 then
			
				if player.y=14 then
					map_save()
					
					world.move(0,1)
					map_load(world.location)
					
					player.oy=0
					player.y=-1
					player.ydir=1
					mymap.oy=0
					mymap.y=0
					movedir=3
				else
					if solid(mymap.x+player.x,mymap.y+player.y+1)=0 then
						movedir=3
					end if
				end if
			else
				player.f=4
				player.xdir=0
				player.ydir=1
				movedir=-4	'' Add slight delay when changing direction
			end if
		end if
		
		if  MultiKey(SC_LEFT) then 
			if player.f=6 then
			
				if (player.x+mymap.x)=0 then
					map_save()
					'map_load(3)	'' Forest to Ice (test)
					
					world.move(-1,0)
					map_load(world.location)
					
					player.ox=0
					player.x=20''19	''14
					
					player.xdir=-1 '0
					mymap.ox=0
					mymap.x=12
					movedir=4
				else
					if solid(mymap.x+player.x-1,mymap.y+player.y)=0 then
						movedir=4
					end if
				end if
			else
				player.f=6
				player.xdir=-1
				player.ydir=0
				movedir=-4	'' Add slight delay when changing direction
			end if
		end if
		
		#if CHEAT=1	
			if  MultiKey(SC_S) then 
				bsave "map.bmp",0
			end if
		#endif
		
	end if


	if player.firedelay=0 then	
		if  MultiKey(SC_Z) then
			'' Standard shot
			'if player.has_armour=true then
				dim as integer screenx=((player.x)*32)+(player.ox)
				dim as integer screeny=((player.y)*32)+(player.oy)
				
				shot_add(screenx,screeny,player.xdir,player.ydir,1)
				player.firedelay=20
			'end if
		end if

		if  MultiKey(SC_X) then 
			if player.has_omni=true then
				if player.omni>0 then 
					dim as integer screenx=((player.x)*32)+(player.ox)
					dim as integer screeny=((player.y)*32)+(player.oy)
					
					shot_add(screenx,screeny,player.xdir,player.ydir,9)
					player.firedelay=20
					player.omni-=1
				end if
			end if
		end if
		
		
		'' Rockets - FIX THIS CHECK IF HAS ROCKETS
		if  MultiKey(SC_X) then 
			if player.has_rockets=true then
				if player.rockets>0 then 
					dim as integer screenx=((player.x)*32)+(player.ox)
					dim as integer screeny=((player.y)*32)+(player.oy)
					
					shot_add(screenx,screeny,player.xdir,player.ydir,2)
					player.firedelay=20
					player.rockets-=1
				end if
			end if
		end if

		'' Heat shots (from mountain)
		if  MultiKey(SC_C) then 
			if player.has_heat=true then
				if player.heat>0 then 
					dim as integer screenx=((player.x)*32)+(player.ox)
					dim as integer screeny=((player.y)*32)+(player.oy)
					
					shot_add(screenx,screeny,player.xdir,player.ydir,3)
					player.firedelay=20
					player.heat-=1
				end if
			end if 
		end if
		
		'' Freeze shots (from ice area)
		if  MultiKey(SC_V) then 
			if player.has_freeze=true then
				if player.freeze>0 then 
					dim as integer screenx=((player.x)*32)+(player.ox)
					dim as integer screeny=((player.y)*32)+(player.oy)
					
					shot_add(screenx,screeny,player.xdir,player.ydir,4)
					player.firedelay=20
					player.freeze-=1
				end if
			end if
		end if
		
	end if


	#if CHEAT=1
		if  MultiKey(SC_1) then one_down=true
		if  MultiKey(SC_1)=0 and one_down=true then 
			player.diamond+=1
			one_down=false
		end if
		
		if  MultiKey(SC_2) then two_down=true
		if  MultiKey(SC_2)=0 and two_down=true then 
			player.hostages+=1
			two_down=false
		end if

		if  MultiKey(SC_3) then three_down=true
		if  MultiKey(SC_3)=0 and three_down=true then 
			player.sat+=1
			three_down=false
		end if
	#endif

	if  MultiKey(SC_SPACE) then spacedown=1
	if  MultiKey(SC_SPACE)=0 and spacedown=1 then
		spacedown=0
		dim as integer actualx=player.x+mymap.x
		dim as integer actualy=player.y+mymap.y
		
		'' Info scan
		select case as const world.location	'current_map
		case 0
			'' SPACE STATION
			''
			
			'' Door terminal
			if map(actualx,actualy-1)=7 then
				if player.has_keycard=true then
					map(actualx+1,actualy+0)=2
					map(actualx+1,actualy+1)=2
					map(actualx+1,actualy+2)=2
					'' Update solid map
					create_solid_map()
					FSOUND_PlaySound(FSOUND_FREE, sample(2))
				end if 
			end if
			
			'' Info Console (about Satellite)
			if map(actualx,actualy-1)=13 then
				ext=90+16
				FSOUND_PlaySound(FSOUND_FREE, sample(2))
			end if
			
			'' Teleport terminal
			if map(actualx,actualy-1)=6 then
				
				if (cog>=1) then
						'' Teleport away!
						tele_add(actualx*32,actualy*32)
						
						for i as integer=0 to 150
							screenlock
								map_drawonly(false)	
							screenunlock
							sleep(10)
						next i
						''
						anim_intro2()
						anim_crash()
							
						'' Landing!
						cog-=1
						with mymap
							.x=0
							.y=0
							.ox=0
							.oy=0
						end with
						
						with player
							.x=6
							.y=6
							.ox=0
							.oy=0
						end with
						map_save()
					
						world.set(2,2)
						map_load(world.location)
				else
					'' Broken message / need cog message
					ext=96
				end if
			end if
			
		case 1
			'' FOREST - Boulder
			if map(actualx+player.xdir,actualy+player.ydir)=4 then ext=93
			'' Tree
			if map(actualx+player.xdir,actualy+player.ydir)=1 then ext=92
			'' Ship
			if map(actualx+player.xdir,actualy+player.ydir)=11 then ext=99
			if solid(actualx+player.xdir,actualy+player.ydir)=11 then ext=99
			
			if ext=99 then
				set_message("Armour Recharged")
				player.health=10
				'' 99 = broken ship...
				
				'' Fixed Ship
				''	+ Teleporter
				'' Rescued Scientists
				''	+ Omni
				'' Recovered Satellites
				'' + Completed!
				
				'' CurrentTask
				''
				select case as const mission
				case 1
					if player.diamond>=10 then
						player.has_teleport=true
						player.diamond=0
						ext=103	'' Working ship!
						mission=2
					else
						ext=99	'' Find diamonds
					end if
					
				case 2
					if player.hostages>=4 then
						player.hostages_rescued=true
						player.hostages=0
						player.has_omni=true 
						player.omni=10
						
						'' Disable other weapons
						player.has_rockets=false
						player.has_freeze=false
						player.has_heat=false
						
						ext=104			'' Got Omniblaster
						mission=3
					else
						 if player.hostages>0 then
							ext=90+17	'' Find more scientists
						 else
							ext=103		'' Working ship!
						 end if
					end if
					
				case 3
					if player.sat=4 then
						ext=90+19	'' Found Satellites
					else
						ext=90+18	'' Find Satellites
					end if
				
				end select 
				
				
				
			end if
			
			''
			if map(actualx+player.xdir,actualy+player.ydir)=3 then ext=101	'' Unstable barrier
		case 2
			'' MOUNTAIN - Lava
			if map(actualx+player.xdir,actualy+player.ydir)=4 then ext=94
			'' Super barrier
			if map(actualx+player.xdir,actualy+player.ydir)=3 then ext=101
		case 3
			'' ICE - Ice block
			if map(actualx+player.xdir,actualy+player.ydir)=1 then ext=95
			'' Super barrier
			if map(actualx+player.xdir,actualy+player.ydir)=3 then ext=101
			
		case 4
			'' LAKE
			'' Super barrier
			if map(actualx+player.xdir,actualy+player.ydir)=3 then ext=101
			
		end select
		
		'' Wall light switch
		'if map(player.x+mymap.x,player.y+mymap.y)=12 then 
		
			'if fixed_switch=false then
			'	if screwdriver=true and newswitch=true and electric=false then fixed_switch=true
			'end if
			
			'if fixed_switch=false then ext=90
			'if fixed_switch=true then ext=91
		'end if
	end if

	
	return ext
end function


