'' Another Armour Ranger Adventure!
''
'' by ssjx (October 2021) [http://ssjx.co.uk]
'' ==============================================================
''
''
#include "header.bi"

#include "font.bi"
dim shared text as myfont

dim shared title_spr as any ptr

sub title_init()
	text.load()
	
	title_spr = ImageCreate( 300, 100,rgb(100,255,100) )
    bload "gfx\title.bmp",title_spr
end sub

''
'' Needs a 32bit screen to work
''
sub fastdim(y as integer)

    Dim buffer As UByte Ptr = ScreenPtr()    
	dim as uinteger c=(640*y*2)      
        
      asm
      	mov eax, [c]		''counter
      	mov ebx, [buffer]	''screen buffer
      	
      dtop:
      	mov cx,[ebx]	''screen pos
  	
      	shr ch			''shift colour bytes
      	shr cl
      	
      	mov [ebx],cx	''put shift colour back 
      	
		add ebx,2	''move to next 2 bytes
						
		sub eax,1	'' decrease count
		jnz dtop	
	 
      end asm   

end sub

''
'' Also needs a 32bit screen to work
''
sub fastcls()

    Dim buffer As UByte Ptr = ScreenPtr()    
	dim as uinteger c=(640*480)    
        
      asm
      	mov eax, [c]		'' counter
      	mov ebx, [buffer]	'' screen buffer
      	mov ecx,0			'' Zero value
      	
      clstop:
      	mov [ebx],ecx	'' put zero in ebx location 
		add ebx,4		'' move to next 4 bytes
		sub eax,1		'' decrease count
		jnz clstop	
      end asm   	
	  
end sub


sub infobar(txt as string)
	fastdim(32)
	
	if txt<>"" then
		dim as integer cx	
		cx=(640-(len(txt)*8))/2
		draw string(cx,8),txt
	end if
end sub


function title_welcome() as boolean
	dim as integer i,j
	dim as string txt(8),tmp

	''

	txt(0)="Answering a garbled distress call, you arrive at a research"
	txt(1)="space station doing top secret work..."
	txt(2)=""
	txt(3)="Move using the Arrow keys, press Z to fire!"
	txt(4)=""
	txt(5)="PRESS SPACE TO START (with intro)"
	txt(6)=""
	txt(7)="PRESS Z TO START (without intro)"
	
	#if CHEAT=1
		txt(8)="CHEAT MODE ENABLED!"
	#endif

	screenlock
		fastcls()
		
		'' Warp stars (static)
		for s as integer=0 to 50
			dim as integer x=int(rnd*640)
			dim as integer y=int(rnd*480)
			
			line (x-5,y)-(x,y),rgb(254,254,254)		'' Slightly different so not picked up below!
			line (x-10,y)-(x-5,y),rgb(128,128,128)
		next s

		put (170,32),title_spr,pset	',trans

		for i=0 to ubound(txt)
			tmp=txt(i)
			text.centre(160+(i*24)-8,tmp)	''300
		next i
	
		'' Recolour the fonts by replacing white pixels
		
		'' Start text colour
		dim as integer yoffset=70+(6*32)
		for i=140 to 500
			for j=0 to 30
 				if point(i,yoffset+j)=&H00ffffff then pset (i,yoffset+j),RGB(255,255,0)
				'pset (i,yoffset+j),RGB(0,255,0)
			next j
		next i
		
		yoffset+=60
		for i=140 to 500
			for j=0 to 30
 				if point(i,yoffset+j)=&H00ffffff then pset (i,yoffset+j),RGB(255,255,0)
				'pset (i,yoffset+j),RGB(0,255,0)
			next j
		next i
			
		'' Footer
		color rgb(255,255,0)
		draw string (2,480-14),VERSION
		draw string (500,480-14),SITEURL
										
	screenunlock
		''	
	While Inkey <> "": Wend
	
	dim as string key
	dim as integer ext=0
	dim as integer esc=0,spac=0,zed=0
	dim as boolean result=true
	
	do
		key=inkey
		if key=Chr(255)&"k" then ext=QUIT
		
		if multikey(SC_ESCAPE) then esc=1
		if multikey(SC_ESCAPE)=0 and esc=1 then ext=QUIT
	
		if multikey(SC_SPACE) then spac=1
		if multikey(SC_SPACE)=0 and spac=1 then ext=1
	
		if multikey(SC_Z) then zed=1
		if multikey(SC_Z)=0 and zed=1 then 
			ext=1
			result=false
		end if
		
		sleep 10,1
	loop while ext=0

	if ext=QUIT then
		end
	end if

	While Inkey <> "": Wend

	return result

end function


sub title_window(y as integer,h as integer)

	'' Slow dim
	dim as integer i,j
	dim as uinteger t,r,g,b
	
	y=(480-h) shr 1
	
	for j=y to y+h
		for i=4 to 640-4
			t=point(i,j)
			r=(t and &H00ff0000) shr 16
			g=(t and &H0000ff00) shr 8
			b=(t and &H000000ff) 
			
			r=r shr 1
			g=g shr 1
			b=b shr 1
			
			pset(i,j),rgb(r,g,b)
		next i
	next j	
end sub


sub title_final(no as integer)
	const as integer height=100	'80
	const as integer bary=(480-height)/2 '240-40
	
	''dim as integer cx
	dim as string txt(6)
	
	title_window(bary,height)
	
	select case as const no
	case 1
		txt(0)="WELL DONE!"
		txt(1)=""
		txt(2)="You have recovered all of the satellites!"	
		txt(3)=""
		txt(4)="#"

	case 2
		txt(0)="A Tree!"
		txt(1)=""
		txt(2)="Busy doing tree things..."	
		txt(3)=""
		txt(4)="#"
	case 3
		txt(0)="A Boulder!"
		txt(1)=""
		txt(2)="Maybe a Rocket will shatter this?"
		txt(3)=""
		txt(4)="#"
		
	case 4
		txt(0)="Lava!"
		txt(1)=""
		txt(2)="This is too hot for your suit..."
		txt(3)=""
		txt(4)="#"

	case 5
		txt(0)="Super Dense Ice"
		txt(1)=""
		txt(2)="Extreme heat may melt it"
		txt(3)=""
		txt(4)="#"

	case 6
		txt(0)="Broken Teleporter!"
		txt(1)=""
		txt(2)="This device requires an Omni-Cog to fix it!"
		txt(3)=""
		txt(4)="#"	

	case 7
		txt(0)="Omni-Cog!"
		txt(1)=""
		txt(2)="Advanced nano-tech capable of repairing damaged devices"
		txt(3)=""
		txt(4)="#"		

	case 8
		txt(0)="Modulus Armour!"
		txt(1)=""
		txt(2)="You have found a prototype suit of armour! This will help"
		txt(3)="protect you from the enemy drones! Press Z to fire!"
		txt(4)=""
		txt(5)="#"			

	case 9
		txt(0)="Your Ship!"	
		txt(1)=""
		txt(2)="You have found your ship, the crash has drained its power."
		txt(3)="It requires 10 crystals to restore its functions."
		txt(4)=""
		txt(5)="#"			
			
	case 10
		txt(0)="Mission Update!"	
		txt(1)=""
		txt(2)="You have found 10 crystals to power your ship!"
		txt(3)="Now find the 4 satellites!"
		txt(4)=""
		txt(5)="#"

	case 11
		txt(0)="Crystal Barrier!"	
		txt(1)=""
		txt(2)="Oddly resistant to your weapons..."
		txt(3)=""
		txt(4)="#"
			
	case 12
		txt(0)="All Scientists recovered!"	
		txt(1)=""
		txt(2)="Return to your ship and scan for further information!"
		txt(3)=""
		txt(4)="#"		
			
	case 13
		txt(0)="Your Ship!"	
		txt(1)=""
		txt(2)="With the power crystals you have collected, your ship"
		txt(3)="is now fully functional. This includes the teleporter!"
		txt(4)=""	
		txt(5)="#"	
			
	case 14
		txt(0)="Omni Blaster!"	
		txt(1)=""
		txt(2)="The rescued scientists modify your suit weapon and create"
		txt(3)="the Omni Blaster! Use this and find the crashed satellites!"
		txt(4)=""		
		txt(5)="#"		
			
	case 15
		txt(0)="EXPLOSION!"	
		txt(1)=""
		txt(2)="An explosion rocks the station and damages your ship!"
		txt(3)="Find a way off this station now!"
		txt(4)=""			
		txt(5)="#"			
			
	case 16
		txt(0)="Tetranet Satellite Network"	
		txt(1)=""
		txt(2)="When operational, these satellites link to form a planet wide barrier"
		txt(3)="that will disrupt the drones and prevent the enemy from opening portals!"
		txt(4)=""
		txt(5)="#"
		
	case 17
		txt(0)="The Scientists!"	
		txt(1)=""
		txt(2)="The scientist you rescued tells you that 3 more teleported to this planet."
		txt(3)="If you can rescue them all, they may be able to help stop this invasion!"
		txt(4)=""	
		txt(5)="#"	
		
	case 18
		txt(0)="Find the Satellites"	
		txt(1)=""
		txt(2)="Find the 4 Tetranet Satellites that crashed into this planet! The rescued"
		txt(3)="scientst will be able to fix them for you to put in orbit!"
		txt(4)=""		
		txt(5)="#"		
	
	case 19
		txt(0)="Recovered the Satellites"	
		txt(1)=""
		txt(2)="You have recovered all of the satellites!"
		txt(3)=""
		txt(4)="#"		
		
	case 20
		txt(0)="Well Done!"	
		txt(1)=""
		txt(2)="With the satellites back in orbit, the Enemy force have been defeated!"
		txt(3)=""
		txt(4)="#"	
		
	case 21
		txt(0)="Mission Failed..."	
		txt(1)=""
		txt(2)="You were not successful this time."
		txt(3)=""
		txt(4)="#"	
		
	case else
		txt(0)="Message "+str(no)	
		txt(1)=""
		txt(2)="Missing a message..."
		txt(3)=""
		txt(4)="#"	
	end select


	for j as integer=0 to ubound(txt)
		dim as string tmp=txt(j)
		dim as uinteger txtcol=rgb(255,255,0)
		
		if tmp="#" then 
			txtcol=rgb(0,255,0)
			tmp="Press Space to Continue"
		end if
		
		dim as integer cx=(640-(len(tmp)*8))/2
		
		'' Offset dark shadow
		color rgb(0,0,0)
		draw string(cx+1,bary+4+(j*14)+1),tmp
		
		'' Actual text
		color txtcol
		draw string(cx,bary+4+(j*14)),tmp	
	next j

end sub




