'' Another Armour Ranger Adventure!
''
'' by ssjx (October 2021) [http://ssjx.co.uk]
'' ==============================================================
''

#include "header.bi"
#include "fmod.bi"

common shared sample() As Integer

type mypoint
	x as integer
	y as integer
end type


dim  shared stars(40) as mypoint

dim shared spr_ship as any ptr
dim shared spr_fire as any ptr
dim shared spr_satellite as any ptr
dim shared spr_tree as any ptr
dim shared spr_grass as any ptr
dim shared spr_station as any ptr

sub anim_init()

	spr_ship= ImageCreate( 128, 32,rgb(100,255,100) )
	bload "gfx/forest/ship.bmp",spr_ship

	spr_fire= ImageCreate( 32, 32,rgb(100,255,100) )
	bload "gfx/station/fire.bmp",spr_fire

	spr_satellite= ImageCreate( 32, 32,rgb(100,255,100) )
	bload "gfx/collect/satellite.bmp",spr_satellite

	spr_tree= ImageCreate( 32, 32,rgb(100,255,100) )
	bload "gfx/intro/tree.bmp",spr_tree

	spr_grass= ImageCreate( 32, 32,rgb(100,255,100) )
	bload "gfx/intro/grass.bmp",spr_grass

	spr_station= ImageCreate( 256, 128,rgb(100,255,100) )
	bload "gfx/intro/station4.bmp",spr_station

	for s as integer=0 to ubound(stars)
		stars(s).x=int(rnd*640)
		stars(s).y=int(rnd*480)
	next s
end sub

''
sub draw_stars()
	color ,rgb(0,0,0)
	cls
	
	for s as integer=0 to ubound(stars)
		pset (stars(s).x,stars(s).y),rgb(255,255,255)
	next s
	
end sub

sub draw_warpstars()
	color ,rgb(0,0,0)
	cls
	
	for s as integer=0 to ubound(stars)
		line (stars(s).x-5,stars(s).y)-(stars(s).x,stars(s).y),rgb(255,255,255)
		line (stars(s).x-10,stars(s).y)-(stars(s).x-5,stars(s).y),rgb(128,128,128)
	next s
	
end sub

sub move_stars(xd as integer, yd as integer)

	for s as integer=0 to ubound(stars)
		with stars(s)
			.x+=xd
			.y+=yd
			
			if .x<0 then .x=640
			if .y<0 then .y=480
		end with
	next s

end sub

''
'' Ship docking with station
''

sub anim_intro()
	''
	dim as boolean extloop=false
	dim as boolean spacedown=false
	
	dim as string txt(4)
	txt(0)="While travelling through space, you pick up"
	txt(1)="a distress signal from a research station!"
	txt(2)="You change course to investigate!"
	
	While Inkey <> "": Wend
	
	do
		screenlock
			draw_warpstars
			
			'' Text
			color rgb(255,255,255)
			for i as integer=0 to ubound(txt)
				draw string (8,8+(i*16)),txt(i)
			next i
			
			'' Ship
			put ((640-128)/2,(480-32)/2),spr_ship,trans
			
			color rgb(0,255,0)
			draw string (450,460),"Press Space to Continue"	
			
		screenunlock
		move_stars(-2,0)
	
		'' Wait for Space up
		if MultiKey(SC_SPACE)=true then spacedown=true 
		
		if spacedown=true then
			if MultiKey(SC_SPACE)=false then
				extloop=true
			end if
		end if
					
		sleep 10
	loop while extloop=false
	
end sub


sub anim_dock()
	''
	
	dim as boolean extloop=false
	dim as boolean spacedown=false
	
	dim as string txt(4)
	txt(0)="Approaching the research station, you notice"
	txt(1)="damage to the exterior. You pull up along side"
	txt(2)="the station and teleport over to find out more..."
	
	While Inkey <> "": Wend
	
	dim as integer ofy=(480-32)/2
	dim as integer ofx=0
	
	dim as boolean press_space=false
	
	do
		screenlock
			draw_stars()
			
			color rgb(255,255,255)
			for i as integer=0 to ubound(txt)
				draw string (8,8+(i*16)),txt(i)
			next i
			
			
			put (640-256-32,ofy-128),spr_station,trans
			
			put (ofx,ofy),spr_ship,trans
			
			if press_space=true then
				color rgb(0,255,0)
				draw string (450,460),"Press Space to Continue"	
			end if
			
		screenunlock
		
		if ofx<(640-256) then 
			ofx+=2
			move_stars(-1,0)
		else
			press_space=true
		end if
	
		'' Wait for Space up
		if MultiKey(SC_SPACE)=true then spacedown=true 
		
		if spacedown=true then
			if MultiKey(SC_SPACE)=false then
				extloop=true
			end if
		end if
					
		sleep 10
		
	loop while extloop=false
	
end sub

''
'' Station exploding / ship falling
''

sub anim_intro2()
	dim as boolean extloop=false
	dim as boolean spacedown=false
	dim as boolean press_space=false
	dim as integer c=0
	
	dim as string txt(4)
	txt(0)="The station explodes!!"
	txt(1)="You manage to teleport away just in time! Your ship gets"
	txt(2)="caught in the blast and is sent hurtling towards the planet!"
	
	While Inkey <> "": Wend
	
	dim as integer fx(3)
	
	for f as integer=0 to ubound(fx)
		fx(f)=f*32
	next
	
	do
		screenlock
			draw_stars()
			
			put (32-c,32-c),spr_station,trans
			
			put ( ((640-128)/2)+c,((480-32)/2)+c),spr_ship,trans
			
			for f as integer=0 to ubound(fx)
				put (((640-128)/2)+fx(f)+c,((480-32)/2)+4+c),spr_fire,trans
			next f
			
			color rgb(255,255,255)
			for i as integer=0 to ubound(txt)
				draw string (8,8+(i*16)),txt(i)
			next i
			
			
			if press_space=true then
				color rgb(0,255,0)
				draw string (450,460),"Press Space to Continue"	
			end if
		screenunlock
		
		if c=256 then 
			'' Explosion sound! (Check so only played once!)
			if press_space=false then 
				FSOUND_PlaySound(FSOUND_FREE, sample(1))
			end if
			
			press_space=true
		end if
		
		if press_space=false then
			c+=1
			move_stars(-2,-2)
		end if
		'' Shuffle flames
		'for f as integer=0 to ubound(fx)
		'	fx(f)+=2
		'	if fx(f)>128 then fx(f)=0
		'next
		

		'' Wait for Space up
		if MultiKey(SC_SPACE)=true then spacedown=true 
		
		if spacedown=true then
			if MultiKey(SC_SPACE)=false then
				extloop=true
			end if
		end if
				
		
		sleep 10
	loop while extloop=false


end sub

'' 
sub anim_crash()
	dim as boolean extloop=false
	dim as boolean spacedown=false
	dim as boolean press_space=false
	
	dim as string txt(4)
	txt(0)="Your ship and the wreckage from the research station"
	txt(1)="plummet to the ground! Luckily your ship is well built"
	txt(2)="and should not be too damaged..."
	
	While Inkey <> "": Wend
	
	dim as integer fx(3)
	
	for f as integer=0 to ubound(fx)
		fx(f)=f*32
	next
	
	dim as integer ofx=0,ofy=0 
	
	'' Blue sky
	color ,rgb(0,128,255)
	do
		FSOUND_Update
		'' Falling
		screenlock
			cls 
			
			color rgb(0,0,0)
			for i as integer=0 to ubound(txt)
				draw string (8,8+(i*16)),txt(i)
			next i
			
			'' Falling satellites + fire
			for s as integer=0 to 2
				put (150+(300*s),ofy),spr_satellite,trans
				put (150+(300*s)+2,ofy+2),spr_fire,trans
			next s
			
			'' Landscape
			for f as integer=0 to 20
				put ((f*32)-ofx,480-64),spr_tree,trans
				put ((f*32)-ofx,480-32),spr_grass,trans
			next f
			
			'' Falling ship + fire
			put ((640-128)/2,ofy),spr_ship,trans
			
			for f as integer=0 to ubound(fx)
				put (((640-128)/2)+fx(f),ofy+2),spr_fire,trans
			next f
			
			if press_space=true then
				color rgb(0,255,0)
				draw string (450,460),"Press Space to Continue"	
			end if
		screenunlock
		
		if ofy=(480-64) then 
		
			'' Explosion sound! (Check so only played once!)
			if press_space=false then 
				FSOUND_PlaySound(FSOUND_FREE, sample(1))
			end if
			
			press_space=true	
		else
			''if ofy<(480-64) then ofy+=2 else extloop=true
			ofy+=2
			ofx+=2
			if ofx=32 then ofx=0
			move_stars(-2,-2)
		end if
	
		'' Wait for Space up
		if MultiKey(SC_SPACE)=true then spacedown=true 
		
		if spacedown=true then
			if MultiKey(SC_SPACE)=false then
				extloop=true
			end if
		end if
				
		sleep 10
	loop while extloop=false

	'' Set background back to black
	color ,rgb(0,0,0)
end sub


''
'' Ship putting satellites in orbit
''

sub anim_orbit()

	dim as boolean extloop=false
	dim as boolean spacedown=false
	dim as boolean press_space=false
	
	dim as string txt(4)
	txt(0)="The rescued scientist were able to repair the recovered"
	txt(1)="satellites and with your ship now working, you are able to put"
	txt(2)="them in orbit of the planet!"
	
	While Inkey <> "": Wend
	
	dim as integer fx(3)
	
	for f as integer=0 to ubound(fx)
		fx(f)=f*32
	next
		
	dim as integer x
	do
		FSOUND_Update
		screenlock
			draw_stars()
			
			color rgb(255,255,255)
			for i as integer=0 to ubound(txt)
				draw string (8,8+(i*16)),txt(i)
			next i
			
			if x>100 then put (100,(480-32)/2),spr_satellite,trans
			if x>200 then put (200,(480-32)/2),spr_satellite,trans
			if x>300 then put (300,(480-32)/2),spr_satellite,trans
			if x>400 then put (400,(480-32)/2),spr_satellite,trans
	
			put (x,(480-32)/2),spr_ship,trans
			
			'x+=2
			''
			if press_space=true then
				color rgb(0,255,0)
				draw string (450,460),"Press Space to Continue"	
			end if
		screenunlock
		
		if x>640 then
			press_space=true
		else
			x+=2
			
			if x=100 then FSOUND_PlaySound(FSOUND_FREE, sample(2))
			if x=200 then FSOUND_PlaySound(FSOUND_FREE, sample(2))
			if x=300 then FSOUND_PlaySound(FSOUND_FREE, sample(2))
			if x=400 then FSOUND_PlaySound(FSOUND_FREE, sample(2))
			
			move_stars(-2,0)
		end if
	
		'' Wait for Space up
		if MultiKey(SC_SPACE)=true then spacedown=true 
		
		if spacedown=true then
			if MultiKey(SC_SPACE)=false then
				extloop=true
			end if
		end if
					
		sleep 10
	loop while extloop=false

end sub

''
'' Active satellites and well done message
''

sub anim_complete()

	dim as string txt(3)
	txt(0)="With the satellites in orbit and broadcasting, the enemy drones"
	txt(1)="stopped functioning and the enemy can no longer portal in more!"
	txt(2)=""
	txt(3)="Well Done!"
		
	screenlock
		draw_stars()
			
		color rgb(255,255,255)
		for i as integer=0 to ubound(txt)
			draw string (8,8+(i*16)),txt(i)
		next i
		
		color rgb(0,255,0)
		
		'line (320,0)-(320,480)
		circle (320,240),100,,,,,F
		
		'draw string ( (640-(9*8))/2 ,32),"Well Done"	
		
		put ((320/2)-16,(240/2)-16 ),spr_satellite,trans
		put ((320/2)-16,240+(240/2)-16 ),spr_satellite,trans
		
		put (320+(320/2)-16,(240/2)-16 ),spr_satellite,trans
		put (320+(320/2)-16,240+(240/2)-16 ),spr_satellite,trans
		
		
		color rgb(0,255,0)
		circle ((320/2),(240/2)),50
		circle ((320/2),240+(240/2)),50
		circle (320+(320/2),(240/2)),50
		circle (320+(320/2),240+(240/2)),50
		
		
		draw string (450,460),"Press Space to Continue"	
	screenunlock
	
	'' Wait for Space up
	dim as boolean extloop=false
	dim as boolean spacedown=false
	
	While Inkey <> "": Wend
	
	do
		if MultiKey(SC_SPACE)=true then spacedown=true 
		
		if spacedown=true then
			if MultiKey(SC_SPACE)=false then
				extloop=true
			end if
		end if
					
		sleep 10
	loop while extloop=false

end sub